from aiohttp import ClientSession

from discovery.engine.abc import Engine
from discovery.engine.response import Response


class AioEngine(Engine):
    def __init__(self, **kwargs):
        super().__init__(**kwargs)

    async def get(self, *args, **kwargs):
        async with ClientSession() as session:
            response = await session.get(*args, **kwargs)
        return Response(response)

    async def put(self, *args, **kwargs):
        async with ClientSession() as session:
            response = await session.put(*args, **kwargs)
        return Response(response)

    async def delete(self, *args, **kwargs):
        async with ClientSession() as session:
            response = await session.delete(*args, **kwargs)
        return Response(response)

    async def post(self, *args, **kwargs):
        async with ClientSession() as session:
            response = await session.post(*args, **kwargs)
        return Response(response)
